SystemOrganization addCategory: #Futuretalk!
SystemOrganization addCategory: #'Futuretalk-Tests'!

CodAMetaComponent subclass: #FuturetalkComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Futuretalk'!

!FuturetalkComponent class methodsFor: 'as yet unclassified' stamp: 'bs 1/31/2008 18:05'!
installingOn: aSymbol for: anObject
	aSymbol = #State ifTrue: [
		anObject meta newAnonymSubclassWithVariables: (Set with: 'methods' with: 'slots').
		anObject meta switchToAnonymClass: anObject.
		anObject class compile: 'slots
	^slots ifNil: [slots := Dictionary new]'.
		anObject class compile: 'slots: val
	slots := val'.
		anObject class compile: 'methods
	^methods ifNil: [methods := Dictionary new]'.
		anObject class compile: 'methods: val
	methods := val'.
		anObject class compile: 'asPrototalkObject
	^ self'.].! !

!FuturetalkComponent class methodsFor: 'as yet unclassified' stamp: 'bs 2/2/2008 10:51'!
receive: aMessage for: anObject
	| method future |
	method := anObject meta protocol methodFor: aMessage for: anObject.
	method ifNil: [ MessageNotUnderstood new receiver: anObject; message: aMessage; signal ].
	future := FutureObject new.
	[future setValue: (method isPrimitive ifTrue: [ 
		 method 
			valueWithReceiver: anObject meta oldObject 
			arguments: aMessage arguments] ifFalse: [ 
		method 
			valueWithReceiver: anObject 
			arguments: aMessage arguments])] fork.
	^ future.! !

Object subclass: #BlubbObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Futuretalk-Tests'!

!BlubbObject methodsFor: 'as yet unclassified' stamp: 'bs 2/1/2008 14:18'!
blubb
	Transcript show: 'blubb'.! !

Object subclass: #FutureObject
	instanceVariableNames: 'semaphore value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Futuretalk'!

!FutureObject methodsFor: 'as yet unclassified' stamp: 'bs 2/3/2008 12:49'!
doesNotUnderstand: aMessage
	semaphore wait.
	^ value perform: (aMessage name asSymbol).! !

!FutureObject methodsFor: 'as yet unclassified' stamp: 'bs 2/2/2008 11:44'!
initialize
	super initialize.
	semaphore := Semaphore new.! !

!FutureObject methodsFor: 'as yet unclassified' stamp: 'bs 2/2/2008 14:03'!
setValue: theValue
	value := theValue.	
	semaphore signal.
	! !

Object subclass: #GetObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Futuretalk-Tests'!

!GetObject methodsFor: 'as yet unclassified' stamp: 'bs 2/1/2008 18:16'!
getBlubb
	^BlubbObject new.! !

TestCase subclass: #FuturetalkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Futuretalk-Tests'!

!FuturetalkTest methodsFor: 'as yet unclassified' stamp: 'bs 2/3/2008 12:47'!
testGeneral
	|blubber getter|
	getter := GetObject new.
	getter asFuturetalkObject.
	blubber := getter getBlubb.
	blubber blubb.! !

!FuturetalkTest methodsFor: 'as yet unclassified' stamp: 'bs 2/2/2008 14:48'!
testString
	|blubb|
	blubb := 'mehr '.
	blubb asFuturetalkObject.
	blubb := blubb, 'bier'.
	self assert: blubb = 'mehr bier'.

	! !
